"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.shouldParse = exports.tf = void 0;

var t = _interopRequireWildcard(require("@babel/types"));

function _interopRequireWildcard(obj) { if (obj && obj.__esModule) { return obj; } else { var newObj = {}; if (obj != null) { for (var key in obj) { if (Object.prototype.hasOwnProperty.call(obj, key)) { var desc = Object.defineProperty && Object.getOwnPropertyDescriptor ? Object.getOwnPropertyDescriptor(obj, key) : {}; if (desc.get || desc.set) { Object.defineProperty(newObj, key, desc); } else { newObj[key] = obj[key]; } } } } newObj.default = obj; return newObj; } }

var tf = 'tf';
exports.tf = tf;

var isTF = function isTF(path) {
  return Boolean(path.findParent(function (_ref) {
    var node = _ref.node;
    return t.isCallExpression(node) && t.isIdentifier(node.callee) && node.callee.name == tf;
  }));
};

var insideTensor = function insideTensor(path) {
  return path.findParent(function (_ref2) {
    var node = _ref2.node;
    return t.isCallExpression(node) && t.isMemberExpression(node.callee) && t.isIdentifier(node.callee.object) && node.callee.object.name === tf && t.isIdentifier(node.callee.property) && node.callee.property.name === 'tensor';
  });
};

var shouldParse = function shouldParse(path) {
  return isTF(path) && !insideTensor(path);
};

exports.shouldParse = shouldParse;
//# sourceMappingURL=utils.js.map